%==========================================================================
%                           WRITING H5 File
%==========================================================================
%file_new='teste.h5'; %Used just for testing
%--------------------------------------------------------------------------
%                           CREATING GROUPS
%--------------------------------------------------------------------------

function [H5file] = writeh5fileexp(file_new,format_version,author,institution,...
    country_code,contact,start_date,end_date,date_of_creation, purpose,data_uuid,...
    data_type,comments,expsetup,recorder_manufacturer,recorder_serial_number,recorder_model,...
    builtin_hydrophone, hydrophone_manufacturer,hydrophone_sensitivity,hydrophone_serial_number,...
    hydrophone_model,calibration_frequency_count,calibration_datetime, calibration_factor,...
    calibration_procedure,reference_frequencies, hydrophone_count,longitude,...
    latitude, depth, frequency_count, frequency_band_definition, f, time_duty_on, time_duty_off,...
    t, averaging_time, A, percentile_count, percentile_list, p);

[H5file]=file_new;

fid = H5F.create(file_new);
plist = 'H5P_DEFAULT';

gid1 = H5G.create(fid,'analysis_metadata',plist,plist,plist);
gid2 = H5G.create(gid1,'experimental',plist,plist,plist);
gid3 = H5G.create(gid2,'recorder',plist,plist,plist);
gid4 = H5G.create(gid2,'hydrophone',plist,plist,plist);
gid5 = H5G.create(gid2,'calibration',plist,plist,plist);
% gid6 = H5G.create(gid1,'numerical_model',plist,plist,plist);
gid7 = H5G.create(fid,'ambient_noise_dataset',plist,plist,plist);
gid8 = H5G.create(gid7,'time',plist,plist,plist);
gid9 = H5G.create(gid7,'sound_pressure_levels',plist,plist,plist);

H5G.close(gid9);
H5G.close(gid8);
H5G.close(gid7);
% H5G.close(gid6);
H5G.close(gid5);
H5G.close(gid4);
H5G.close(gid3);
H5G.close(gid2);
H5G.close(gid1);
H5F.close(fid);

%--------------------------------------------------------------------------
%                           GLOBAL ATTRIBUTES
%--------------------------------------------------------------------------
h5writeatt(file_new,'/', 'format_version',format_version);
h5writeatt(file_new,'/','author',author);
h5writeatt(file_new,'/','institution',institution); 
h5writeatt(file_new,'/','country_code',country_code); 
h5writeatt(file_new,'/','contact',contact); 
h5writeatt(file_new,'/','start_date',start_date);
h5writeatt(file_new,'/','end_date',end_date);
h5writeatt(file_new,'/','date_of_creation', date_of_creation);
h5writeatt(file_new,'/','purpose',purpose);
h5writeatt(file_new,'/','data_uuid',data_uuid);
h5writeatt(file_new,'/','data_type',data_type);
h5writeatt(file_new,'/','comments',comments);
%--------------------------------------------------------------------------
%                    ANALYSIS METADATA / EXPERIMENTAL
%--------------------------------------------------------------------------
h5writeatt(file_new,'/analysis_metadata/experimental','expsetup',expsetup)
%--------------------------------------------------------------------------
%              ANALYSIS METADATA / EXPERIMENTAL / RECORDER
%--------------------------------------------------------------------------
h5writeatt(file_new,'/analysis_metadata/experimental/recorder','recorder_manufacturer',recorder_manufacturer);
h5writeatt(file_new,'/analysis_metadata/experimental/recorder','recorder_serial_number',recorder_serial_number);
h5writeatt(file_new,'/analysis_metadata/experimental/recorder','recorder_model',recorder_model);
h5writeatt(file_new,'/analysis_metadata/experimental/recorder','builtin_hydrophone',builtin_hydrophone);
%--------------------------------------------------------------------------
%              ANALYSIS METADATA / EXPERIMENTAL / HYDROPHONE
%--------------------------------------------------------------------------
h5writeatt(file_new,'/analysis_metadata/experimental/hydrophone','hydrophone_manufacturer',hydrophone_manufacturer);
h5writeatt(file_new,'/analysis_metadata/experimental/hydrophone','hydrophone_sensitivity',hydrophone_sensitivity);
h5writeatt(file_new,'/analysis_metadata/experimental/hydrophone','hydrophone_serial_number',hydrophone_serial_number);
h5writeatt(file_new,'/analysis_metadata/experimental/hydrophone','hydrophone_model',hydrophone_model);
%--------------------------------------------------------------------------
%              ANALYSIS METADATA / EXPERIMENTAL / CALIBRATION
%--------------------------------------------------------------------------
%CALIBRATION_FREQUENCY_COUNT
h5create(file_new,'/analysis_metadata/experimental/calibration/calibration_frequency_count',size(calibration_frequency_count)); 
h5write(file_new,'/analysis_metadata/experimental/calibration/calibration_frequency_count',calibration_frequency_count);
%CALIBRATION_DATETIME
hdf5write(file_new, '/analysis_metadata/experimental/calibration/calibration_datetime', calibration_datetime,'WriteMode', 'append');
%CALIBRATION_FACTOR
h5create(file_new,'/analysis_metadata/experimental/calibration/calibration_factor',size(calibration_factor)); 
h5write(file_new,'/analysis_metadata/experimental/calibration/calibration_factor',calibration_factor);
%CALIBRATION_PROCEDURE
hdf5write(file_new, '/analysis_metadata/experimental/calibration/calibration_procedure', calibration_procedure,'WriteMode', 'append');
%REFERENCE_FREQUENCIES
h5create(file_new,'/analysis_metadata/experimental/calibration/reference_frequencies',size(reference_frequencies)); 
h5write(file_new,'/analysis_metadata/experimental/calibration/reference_frequencies',reference_frequencies);
%--------------------------------------------------------------------------
%                   ANALYSIS METADATA / NUMERICAL MODEL
%--------------------------------------------------------------------------
% h5writeatt(file_new,'/analysis_metadata/numerical_model','ais_database',ais_database);
% %SOURCE LEVELS
% h5create(file_new,'/analysis_metadata/numerical_model/source_levels',size(source_levels)); 
% h5write(file_new,'/analysis_metadata/numerical_model/source_levels',source_levels);
% 
% h5writeatt(file_new,'/analysis_metadata/numerical_model','bathymetry_database',bathymetry_database);
% h5writeatt(file_new,'/analysis_metadata/numerical_model','temperature_database',temperature_database);
% h5writeatt(file_new,'/analysis_metadata/numerical_model','salinity_database',salinity_database);
% h5writeatt(file_new,'/analysis_metadata/numerical_model','sound_speed_profile_model',sound_speed_profile_model);
% h5writeatt(file_new,'/analysis_metadata/numerical_model','propagation_model',propagation_model);
% h5writeatt(file_new,'/analysis_metadata/numerical_model','numeric_data_calibration',numeric_data_calibration);
%--------------------------------------------------------------------------
%                        AMBIENT NOISE DATASET - POSITION
%--------------------------------------------------------------------------
%HYDROPHONE COUNT
h5create(file_new,'/ambient_noise_dataset/position/hydrophone_count',size(hydrophone_count)); 
h5write(file_new,'/ambient_noise_dataset/position/hydrophone_count',hydrophone_count);
%TOTAL NUMBER OF GRID POINTS
% h5create(file_new,'/ambient_noise_dataset/position/total_number_of_grid_points',size(total_number_of_grid_points)); 
% h5write(file_new,'/ambient_noise_dataset/position/total_number_of_grid_points',total_number_of_grid_points);
%LONGITUDE
h5create(file_new,'/ambient_noise_dataset/position/longitude',size(longitude)); 
h5write(file_new,'/ambient_noise_dataset/position/longitude',longitude);
%LATITUDE
h5create(file_new,'/ambient_noise_dataset/position/latitude',size(latitude)); 
h5write(file_new,'/ambient_noise_dataset/position/latitude',latitude);
%DEPTH
h5create(file_new,'/ambient_noise_dataset/position/depth',size(depth)); 
h5write(file_new,'/ambient_noise_dataset/position/depth',depth);
%--------------------------------------------------------------------------
%                        AMBIENT NOISE DATASET - FREQUENCY
%--------------------------------------------------------------------------
%FREQUENCY COUNT
h5create(file_new,'/ambient_noise_dataset/frequency/frequency_count',size(frequency_count)); 
h5write(file_new,'/ambient_noise_dataset/frequency/frequency_count',frequency_count);
%FREQUENCY BAND DEFINITION
hdf5write(file_new, '/ambient_noise_dataset/frequency/frequency_band_definition', frequency_band_definition,'WriteMode', 'append');
%FREQUENCY
h5create(file_new,'/ambient_noise_dataset/frequency/frequency',size(f)); %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/frequency/frequency',f); %Search for PAMGUIDE VARIABLE NAME
%--------------------------------------------------------------------------
%                        AMBIENT NOISE DATASET - TIME
%--------------------------------------------------------------------------
%TIME DUTY ON
h5writeatt(file_new,'/ambient_noise_dataset/time','time_duty_on',time_duty_on);
%TIME DUTY OFF
h5writeatt(file_new,'/ambient_noise_dataset/time','time_duty_off',time_duty_off);
%TIME COUNT
h5create(file_new,'/ambient_noise_dataset/time/time_count',[1 1]); %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/time/time_count',length(t)); %Search for PAMGUIDE VARIABLE NAME
%TIME
h5create(file_new,'/ambient_noise_dataset/time/time',size(t)); %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/time/time',t); %Search for PAMGUIDE VARIABLE NAME
%--------------------------------------------------------------------------
%                 AMBIENT NOISE DATASET - SOUND PRESSURE LEVEL
%--------------------------------------------------------------------------
%AVERAGIN TIME
h5writeatt(file_new,'/ambient_noise_dataset/sound_pressure_levels','averaging_time',averaging_time);
%SPL VALUES
h5create(file_new,'/ambient_noise_dataset/sound_pressure_levels/spl_values',size(A)); %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/sound_pressure_levels/spl_values',A); %Search for PAMGUIDE VARIABLE NAME
%--------------------------------------------------------------------------
%             AMBIENT NOISE DATASET - SOUND PRESSURE LEVEL STATS
%--------------------------------------------------------------------------
%PERCENTILE COUNT
h5create(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_count',size(percentile_count)); %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_count',percentile_count); %Search for PAMGUIDE VARIABLE NAME
%PERCENTILE LIST
h5create(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_list',size(percentile_list));  %Search for PAMGUIDE VARIABLE NAME
h5write(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_list',percentile_list); %Search for PAMGUIDE VARIABLE NAME
%PERCENTILE VALUES
h5create(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_values',size(p)); 
h5write(file_new,'/ambient_noise_dataset/sound_pressure_levels_stats/percentile_values', p); 
%==========================================================================

%--------------------------------------------------------------------------
%Delete the myfile.mat which contains the variables p,t,f and A calculated
%at PG_Viewer.m file.
%delete('myfile.mat');
%--------------------------------------------------------------------------

return